import { assert, test } from 'vitest';
import { SchemaUtil } from "../js/cordra/SchemaUtil";

test('get preview property', () => {
    const idSubSchema = {
        type: "string",
        cordra: {
            type: {
                autoGeneratedField: "handle"
            }
        }
    };

    const idOutput = SchemaUtil.getDeepCordraSchemaProperty(idSubSchema, 'preview');
    assert.notExists(idOutput);

    const nameSubSchema = {
        type: "string",
        title: "Name",
        minLength: 1,
        cordra: {
            preview: {
                showInPreview: true,
                isPrimary: false
            }
        }
    };

    const nameOutput = SchemaUtil.getDeepCordraSchemaProperty(nameSubSchema, 'preview') as Record<string, unknown>;
    assert.exists(nameOutput);
    assert.isTrue(nameOutput.showInPreview);
    assert.isFalse(nameOutput.isPrimary);

    const oldNameSubSchema = {
        "type": "string",
        "title": "Name",
        "minLength": 1,
        "net.cnri.repository": {
            preview: {
                showInPreview: true,
                isPrimary: false
            }
        }
    };

    const oldNameOutput = SchemaUtil.getDeepCordraSchemaProperty(oldNameSubSchema, 'preview') as Record<string, unknown>;
    assert.exists(oldNameOutput);
    assert.isTrue(oldNameOutput.showInPreview);
    assert.isFalse(oldNameOutput.isPrimary);
});

test("getDeepCordraSchemaProperty", () => {
    const jsonNode = {
        "cordra": {
            a: {
                b: "good",
                c: "good"
            }
        },
        "net.cnri.repository": {
            a: {
                b: "bad",
                d: "good"
            },
            e: "good"
        }
    };
    const atNothing = SchemaUtil.getDeepCordraSchemaProperty(jsonNode);
    assert.equal(atNothing, jsonNode.cordra);
    const useCordraFirst = SchemaUtil.getDeepCordraSchemaProperty(jsonNode, "a", "b");
    assert.equal(useCordraFirst, "good");
    const useCordraOnly = SchemaUtil.getDeepCordraSchemaProperty(jsonNode, "a", "c");
    assert.equal(useCordraOnly, "good");
    const useOld = SchemaUtil.getDeepCordraSchemaProperty(jsonNode, "a", "d");
    assert.equal(useOld, "good");
    const useOld2 = SchemaUtil.getDeepCordraSchemaProperty(jsonNode, "e");
    assert.equal(useOld2, "good");
});
